<h1>Représentation visuelle des migrations</h1>

<%= javascript_include_tag 'LoadingDiv' %>
<%= javascript_include_tag 'molecularviz/glge' %>
<%= javascript_include_tag 'molecularviz/cluster/ClusterManager' %>
<%= javascript_include_tag 'molecularviz/cluster/ClusterManager.Camera' %>
<%= javascript_include_tag 'molecularviz/cluster/Cluster' %>
<%= javascript_include_tag 'molecularviz/cluster/Cluster.Node' %>
<%= javascript_include_tag 'molecularviz/cluster/Cluster.Process' %>
<%= javascript_include_tag 'molecularviz/cluster/Cluster.Mark' %>
<%= javascript_include_tag 'molecularviz/cluster/Cluster.AxisSphere' %>
<%= javascript_include_tag 'molecularviz/cluster/Cluster.SpherePosition' %>

<% content_tag :div, :id => "canvas-info-pick", :class => "canvas-info-left" do -%>
	<%= content_tag :h2, 'Pick a node', :id => 'info-pick-title' %>
	<%= content_tag :span, '&nbsp;', :id => 'info-pick-display' %>
<% end -%>

<% content_tag :div, :id => "canvas-info-track", :class => "canvas-info-right" do -%>
	<%= content_tag :h2, 'Tracked : None', :id => 'info-track-title' %>
	<%= content_tag :span, '&nbsp;', :id => 'info-track-display' %>
<% end -%>

<% content_tag :div, :id => "loading", :class => "dynamic-graph" do -%>
	Loading ...
<% end -%>

<% content_tag :div, :id => 'canvas-container' do -%>
	<canvas id="canvas-molecular" width="1024px" height="768px"></canvas>
<% end -%>

<% javascript_tag do %>
	var loader = new LoadingDiv("loader", "loading", "canvas-container", 1);
	
	var doc = new GLGE.Document();
	doc.load("<%= javascript_path 'molecularviz/scene.xml' -%>");
	doc.onLoad = function()
	{
		<% if @debug %>
		ClusterManager.createSingleton("manager", "canvas-molecular", doc, "debug");
		<% else %>
		ClusterManager.createSingleton("manager", "canvas-molecular", doc);
		<% end %>
	}
	Event.observe(window, 'unload', function(){
	window.onbeforeunload = ClusterManager.destroy();
	});
<% end -%>

<% if @debug %>
	<%= javascript_include_tag 'molecularviz/debug' %>
	<% content_tag :div, :id => 'framerate' do %>
		<% content_tag :div, :id => 'debug' do %>
		<% end %>
	<% end %>
	<% content_tag :div, :id => 'control' do %>
	<%= text_area_tag 'console', nil, :cols => 132, :rows => 44 %>
	<% form_tag do -%>
		<%= submit_tag "Ajouter un nœud", :onclick => 'addNodeDebug();', :type => 'button' %>
		<%= tag('br') %>
		<%= select_tag 'nodeSelector', '<option value="">Selectionner le noeud</option>' %>
		<%= submit_tag "Ajouter un process", :onclick => 'addProcessDebug();', :type => 'button' %>
		<%= tag('br') %>
		<%= select_tag 'from', '<option value="">Selectionner le nœud de départ</option>' , :onclick => "populateProcesses();"%>
		<%= select_tag 'process', '<option value="">Selectionner le processus</option>' %>
		<%= select_tag 'to', '<option value="">Selectionner le nœud d\'arrivée</option>' %>

		<%= submit_tag "Migrer", :onclick => 'migrate();', :type => 'button' %>
		<%= tag('br') %>
		<%= submit_tag "Redimensionner", :onclick => 'document.getElementById("canvas-molecular").style.width="500px"; document.getElementById("canvas-molecular").style.height="200px";', :type => 'button' %>
		<%= submit_tag "Visualiser", :onclick => 'Cluster.play();', :type => 'button' %>
		<%= submit_tag "Pause", :onclick => 'Cluster.pause();', :type => 'button' %>
		<%= check_box_tag 'Mark', :onclick => 'if(this.checked){Cluster.DISPLAY_MARKS = true;}else{Cluster.DISPLAY_MARKS = false;}' %>
		<%= label_tag 'Mark', "Afficher les traces de migrations" %>
	<% end -%>
	<% end -%>
<% end %>
				
<%= periodically_call_remote( 
	:url => {:controller => 'tracker', :action => 'ajax_update_molecularGraph'},
	:condition => "ClusterManager.getSingleton() != null",
	:method => :get,
	:frequency => 1, 
	:with => "'lastMigId=' + ClusterManager.getSingleton().lastMigId"
)
%>
